// xdiag.cpp
// Banco de pruebas algoritmo de Jacobi

//----Cabeceras ---
// biblioteca estndar
#include <iostream>  
#include <string>
// control de errores
#include <error.h>
// utilidades matemticas
#include <matutil.h>
// Clase RDiag
#include <rdiagonal.h>
#include <linalg.h>
#include <alineal.h>


// Espacio de nombres estndar
using namespace std;

//---main---

int main () 
{      
    // Lee matriz real de disco
    int n;
    cout << " dimensin de la matriz? "; cin >> n;
    RMatriz m(n,n);
    string fichero;
    cout << " Nombre fichero matriz? "; cin>> fichero;
    m.lee(fichero);

    cout << "matriz real m = " << m << endl;

    // Construye una matriz simtrica a partir de m;
    SMatriz sm(m);

    // Operador <<
    cout << " Matriz simtrica sm = " << sm << endl;

    // Inicializa una mquina de diagonalizar
    RDiagonal xd;
    // Establece matriz
    // Todos los parmetros por defecto
    xd.eMatriz(m);
    // Imprime resultados
    cout << "matriz diagonalizada" << xd.diagonal() << endl;
    cout << "autovectores" << xd.autovectores() << endl;
    //Modificacion
    cout <<"Ahora asociamos cada auntovector a su autovalor."<<endl;
    RVector a(n);
    cout <<"Los autovalores lamda(1),lamda(2)...lamda(n) son los elementos diagonales de"<<endl;
    cout <<"la matriz diagonalizada,siendo lamda(1)=m(1,1)...lamda(n)=m(n,n)."<<endl;
    cout <<"Elegiremos las componentes de un vector (a).Si queremos conocer el"<<endl;
    cout <<"autovector asociado al autovalor lamda(1),(a) tendra la forma"<<endl;
    cout <<"a=(1,0,0...,0).Si queremos conocer el autovector asociado a lambda(2),"<<endl;
    cout <<"(a) tendra la forma a=(0,1,0...,0).Asi sucesivamente."<<endl;
	for (int i = 1; i <= n; i++)
	{
	    cout << "a("<<i<<")?" ;
	    cin>>a(i);
	}
cout <<"El autovector asociado al autovalor que has elegido es; "<<endl;
cout << xd.autovectores()*a<<endl;
    return EXITO;
} 













